FIELD_SIZES = {
    'TIPO_DE_REGISTRO': 2,
    'DATA_DO_PREGAO': 8,
    'CODIGO_BDI': 2,
    'CODIGO_DE_NEGOCIACAO': 12,
    'TIPO_DE_MERCADO': 3,
    'NOME_DA_EMPRESA': 12,
    'ESPECIFICACAO_DO_PAPEL': 10,
    'PRAZO_EM_DIAS_DO_MERCADO_A_TERMO': 3,
    'MOEDA_DE_REFERENCIA': 4,
    'PRECO_DE_ABERTURA': 13,
    'PRECO_MAXIMO': 13,
    'PRECO_MINIMO': 13,
    'PRECO_MEDIO': 13,
    'PRECO_ULTIMO_NEGOCIO': 13,
    'PRECO_MELHOR_OFERTA_DE_COMPRA': 13,
    'PRECO_MELHOR_OFERTA_DE_VENDAS': 13,
    'NUMERO_DE_NEGOCIOS': 5,
    'QUANTIDADE_NEGOCIADA': 18,
    'VOLUME_TOTAL_NEGOCIADO': 18,
    'PRECO_DE_EXERCICIO': 13,
    'INDICADOR_DE_CORRECAO_DE_PRECOS': 1,
    'DATA_DE_VENCIMENTO': 8,
    'FATOR_DE_COTACAO': 7,
    'PRECO_DE_EXERCICIO_EM_PONTOS': 13,
    'CODIGO_ISIN': 12,
    'NUMERO_DE_DISTRIBUICAO': 3
}

DATE_COLUMNS = (
    "DATA_DO_PREGAO",
    "DATA_DE_VENCIMENTO"
)

FLOAT32_COLUMNS = (
    'PRECO_DE_ABERTURA',
    'PRECO_MAXIMO',
    'PRECO_MINIMO',
    'PRECO_MEDIO',
    'PRECO_ULTIMO_NEGOCIO',
    'PRECO_MELHOR_OFERTA_DE_COMPRA',
    'PRECO_MELHOR_OFERTA_DE_VENDAS',
    'PRECO_DE_EXERCICIO',
    'PRECO_DE_EXERCICIO_EM_PONTOS',    
)

FLOAT64_COLUMNS = (
    "VOLUME_TOTAL_NEGOCIADO",
    "QUANTIDADE_NEGOCIADA"
)

UINT32_COLUMNS = (
    "FATOR_DE_COTACAO",
    "PRAZO_EM_DIAS_DO_MERCADO_A_TERMO",
    "NUMERO_DE_NEGOCIOS",
    "NUMERO_DE_DISTRIBUICAO",
    'TIPO_DE_REGISTRO', 
)

STRING_COLUMNS = (
    "CODIGO_DE_NEGOCIACAO",
    "NOME_DA_EMPRESA",
    "CODIGO_ISIN"
)

CATEGORY_COLUMNS = (
    "INDICADOR_DE_CORRECAO_DE_PRECOS", 
    'TIPO_DE_MERCADO', 
    'CODIGO_BDI', 
    "MOEDA_DE_REFERENCIA",
    "ESPECIFICACAO_DO_PAPEL"
)

MARKETS = {
    '010':'VISTA',
    '012':'EXERCICIO_DE_OPCOES_DE_COMPRA',
    '013':'EXERCÍCIO_DE_OPCOES_DE_VENDA',
    '017':'LEILAO',
    '020':'FRACIONARIO',
    '030':'TERMO',
    '050':'FUTURO_COM_RETENCAO_DE_GANHO',
    '060':'FUTURO_COM_MOVIMENTACAO_CONTINUA',
    '070':'OPCOES_DE_COMPRA',
    '080':'OPCOES_DE_VENDA'
}

INDOPC = {
    '0':'0',
    '1':'US$',
    '2':"TJLP",
    '8':"IGPM",
    '9':"URV"
}

CODBDI = {
    '00':'0',
    '02':"LOTE_PADRAO",
    '05':"SANCIONADAS PELOS REGULAMENTOS BMFBOVESPA",
    '06':"CONCORDATARIAS",
    '07':"RECUPERACAO_EXTRAJUDICIAL",
    '08':"RECUPERAÇÃO_JUDICIAL",
    '09':"REGIME_DE_ADMINISTRACAO_ESPECIAL_TEMPORARIA",
    '10':"DIREITOS_E_RECIBOS",
    '11':"INTERVENCAO",
    '12':"FUNDOS_IMOBILIARIOS",
    '13':'13',
    '14':"CERT.INVEST/TIT.DIV.PUBLICA",
    '18':"OBRIGACÕES",
    '22':"BÔNUS(PRIVADOS)",
    '26':"APOLICES/BÔNUS/TITULOS PUBLICOS",
    '32':"EXERCICIO_DE_OPCOES_DE_COMPRA_DE_INDICES",
    '33':"EXERCICIO_DE_OPCOES_DE_VENDA_DE_INDICES",
    '34':'34',
    '35':'35',
    '36':'36',
    '37':'37',
    '38':"EXERCICIO_DE_OPCOES_DE_COMPRA",
    '42':"EXERCICIO_DE_OPCOES_DE_VENDA",
    '46':"LEILAO_DE_NAO_COTADOS",
    '48':"LEILAO_DE_PRIVATIZACAO",
    '49':"LEILAO_DO_FUNDO_RECUPERACAO_ECONOMICA_ESPIRITO_SANTO",
    '50':"LEILAO",
    '51':"LEILAO_FINOR",
    '52':"LEILAO_FINAM",
    '53':"LEILAO_FISET",
    '54':"LEILAO_DE_ACÕES_EM_MORA",
    '56':"VENDAS_POR_ALVARA_JUDICIAL",
    '58':"OUTROS",
    '60':"PERMUTA_POR_ACÕES",
    '61':"META",
    '62':"MERCADO_A_TERMO",
    '66':"DEBENTURES_COM_DATA_DE_VENCIMENTO_ATE_3_ANOS",
    '68':"DEBENTURES_COM_DATA_DE_VENCIMENTO_MAIOR_QUE_3_ANOS",
    '70':"FUTURO_COM_RETENCAO_DE_GANHOS",
    '71':"MERCADO_DE_FUTURO",
    '74':"OPCOES_DE_COMPRA_DE_INDICES",
    '75':"OPCOES_DE_VENDA_DE_INDICES",
    '78':"OPCOES_DE_COMPRA",
    '82':"OPCOES_DE_VENDA",
    '83':"BOVESPAFIX",
    '84':"SOMA_FIX",
    '90':"TERMO_VISTA_REGISTRADO",
    '96':"MERCADO_FRACIONARIO",
    '99':"TOTAL_GERAL"
}
